1. Two Sum(Leetcode)

前段时间刷了一下leetcode的热门top100题目,在此做一下记录。记录刷题过程中的思路和想法,当然有的并不是最优解。

题目:

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

题目源地址:
https://leetcode-cn.com/problems/two-sum

作为第一道题目还是很简单的,暴力法就可以了,很多人用哈希,感觉哈希在初始化的时候还是很耗时间的,对于这种题目,暴力解法即可:

package main

import "fmt"

func twoSum(nums []int, target int) []int {
    var result []int
    for index, x := range nums {
        for j := index + 1; j < len(nums); j++ {
            if x+nums[j] == target {
                result = append(result, index)
                result = append(result, j)
                break
            }
        }
        if len(result) != 0 {
            break
        }
    }
    return result
}

func main() {
    arr := []int{1, 2, 3, 4, 5}
    value1 := 6
    slice := twoSum(arr, value1)
    fmt.Println(slice)
}

没什么花哨的,遍历就行了。

你可能感兴趣的:(1. Two Sum(Leetcode))